/*
 *  Permission hereby granted to use and change this software, and make
 *  derivative works based on this code, as long as it mentions initial
 *  author - Roman Mitnitski (mitnits@shani.net) 
 * 
 *  ROMAN MITNITSKI MAKES NO WARRANTY OF ANY KIND 
 *  WITH REGARD TO THIS SOFWARE, INCLUDING, BUT NOT LIMITED TO, THE 
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE.  Roman Mitnitski will not be liable 
 *  for errors contained herein or direct, indirect, special, incidental 
 *  or consequential damages in connection with the furnishing,
 *  performance, or use of this program.               
 */

#include "forms.h"
#include "xbackdrop.h"
#include "newbg.h"
#include <stdlib.h>

extern int save_colors ;
extern Display *dpy;
extern int screen;
extern Window root;
extern  char *display_name;
void SetRootWindow(char *tline);
Pixmap rootXpm;

#ifndef XBACKDROP_DIR
#define XBACKDROP_DIR "/usr/lib/X11/backdrops"
#endif
Window Mainwin;

char system_backdrop[1024];

FD_newbg *fd_newbg;

typedef struct backdrop_
{
  int deflt;
  char * name;
  char * xpmfile;
} backdrop;

char * rcfile="/.backdrops";

FD_xbackdrop *fd_xbackdrop;

backdrop backdrops[256];
int backd_cnt=0;
int selected=0;
int gui_mode=0;

FL_OBJECT * pixmap, * pixframe, *pixlabel;
extern FL_FORM * mainform;
void fill_list(FL_OBJECT *list)
{
  FILE * backdrlist;
  char line[1024];
  char userfile[1024];
  int  i=0;

  strcpy(userfile,(char *)getenv("HOME"));
  strcat(userfile,rcfile);
  backdrlist=fopen(userfile,"r");
  if ( backdrlist==NULL) /* File not found ??*/
    {/* Copy the default settings */
      FILE * in, *out;
      in=fopen(system_backdrop,"r");
      out=fopen(userfile,"w");
      if (in==NULL) 
	{
	  puts("xbackdrop is not installed properly!");
	  exit(1);
	}
      while(!feof(in))
	{
	  fgets(line,1024,in);
	  if (feof(in)) break;
	  fprintf(out,"%s",line);
	}
      fclose(in);fclose(out);
      backdrlist=fopen(userfile,"r");
      if ( backdrlist==NULL) /* Something is really screwy....*/
	{
	  puts("Can't create user background database");
	  exit(1);
	}
    }
  while (!feof(backdrlist))
    {
      fgets(line,1024,backdrlist);
      if (feof(backdrlist)) break;
      line[strlen(line)-1]=0; /* Strip \n */
      if (strcmp(line,"@@default")==0)
	{
	  backdrops[i].deflt=1;
	  selected=i;
	  fgets(line,1024,backdrlist);
	  line[strlen(line)-1]=0; /* Strip \n */
	}
      backdrops[i].name=calloc(1,strlen(line)+1);
      strcpy(backdrops[i].name,line);
      fgets(line,1024,backdrlist);
      line[strlen(line)-1]=0; /* Strip \n */
      backdrops[i].xpmfile=calloc(1,strlen(line)+1);
      strcpy(backdrops[i].xpmfile,line);
      fl_add_browser_line(list,backdrops[i].name);
      i++;
    }
  backd_cnt=i;
  fclose(backdrlist);
}

void update_list()
{
  FILE * backdrlist;
  char line[1024];
  char userfile[1024];
  int i=0;

  strcpy(userfile,getenv("HOME"));
  strcat(userfile,rcfile);

  backdrlist=fopen(userfile,"w");
  if (backdrlist==NULL) {printf("Can't update user database!\n");exit(1);}
  for (i=0;i<backd_cnt;i++)
    {
      if ( backdrops[i].deflt==1)
	  fprintf(backdrlist,"@@default\n");
      fprintf(backdrlist,"%s\n",backdrops[i].name);
      fprintf(backdrlist,"%s\n",backdrops[i].xpmfile);
    }
  fclose(backdrlist);
}
usage()
{
  puts("xbackdrop - GUI selector for root window background");
  puts("Usage: xbackdrop [-gui]");
  exit(0);
}
int main(int argc, char *argv[])
{
   FL_IOPT flopt;  
   
   flopt.debug=0;
   flopt.borderWidth=-2;
   
   fl_set_defaults(FL_PDDebug| FL_PDBorderWidth/*|FL_PDButtonLabelSize*/,
		   &flopt);  
   sprintf(system_backdrop,"%s/index",XBACKDROP_DIR);
#if FL_REVISION>=80
   fl_initialize(&argc, argv, "xbackdrop", 0, 0);
#else
   fl_initialize(argv[0], "xbackdrop", 0, 0, &argc, argv);
#endif

   fd_xbackdrop = create_form_xbackdrop();
   fd_newbg = create_form_newbg();

   fill_list(fd_xbackdrop->backlist);
   /* fill-in form initialization code */

   if (argc==1) /* We have simple command-line invocation here */
     gui_mode=0;
   if (argc==2 && strcmp (argv[1],"-gui")==0)
     gui_mode=1;
   if (argc!=1 && argc!=2) usage();
   if (selected==0) gui_mode=1;

   if (gui_mode)
     {
       /* show the first form */
       mainform=fd_xbackdrop->xbackdrop;
       Mainwin=fl_show_form(fd_xbackdrop->xbackdrop,FL_PLACE_CENTER,FL_FULLBORDER,"xbackdrop");
       if (selected!=0) 
	 {
	   fl_select_browser_line(fd_xbackdrop->backlist,selected+1);
	   selected_pixmap(fd_xbackdrop->backlist, 0L);
	 }
       fl_do_forms();
     }
   else
     {
       Atom prop, type;
       int format,i;
       unsigned long length, after;
       unsigned char *data;

       dpy=fl_get_display();
       screen = DefaultScreen(dpy);
       root = RootWindow(dpy, screen);
       
       SetRootWindow(backdrops[selected].xpmfile);
       
       prop = XInternAtom(dpy, "_XSETROOT_ID", False);
       
       (void)XGetWindowProperty(dpy, root, prop, 0L, 1L, True, AnyPropertyType,
				&type, &format, &length, &after, &data);
       if ((type == XA_PIXMAP) && (format == 32) && (length == 1) && (after == 0))
	 XKillClient(dpy, *((Pixmap *)data));
       
       XChangeProperty(dpy, root, prop, XA_PIXMAP, 32, PropModeReplace,
		       (unsigned char *) &rootXpm, 1);
       XSetCloseDownMode(dpy, RetainPermanent);
       exit(0);
     }
   return 0;
}

